const assert = require('assert');
const { Given, When, Then } = require('@cucumber/cucumber');
const OpenAPISchemaValidator = require('openapi-schema-validator').default;

const fs = require('fs');

const schemaLocation = './test/mock/swagger.json';

Given('the test schema', function() {
  this.schema = JSON.parse(fs.readFileSync(schemaLocation));
});

When('it is validated', function() {
  const validator = new OpenAPISchemaValidator({ version: 3 });
  this.validation = validator.validate(this.schema);
});

Then('it matches the OpenAPI specification', function() {
  // According to the docs this should return a valid:boolean 
  // but if you look at the code it just returns a list of errors 
  // which is empty for a valid result
  assert.equal(this.validation.errors.length, 0);
});